/***********************************************************

	redDML.h

	Version 0.90: 2009/06/04

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/


#ifndef REDDML_H
#define REDDML_H

#include <inttypes.h>
#include <avr/interrupt.h>
#include "WProgram.h"

#define cbi(sfr, bit) ((sfr) &= ~_BV(bit))
#define sbi(sfr, bit) ((sfr) |= _BV(bit))

#define	CLCD_BOOSTER	10


/***********************************************************
	vbgtH[̒`
***********************************************************/

#define	REDUINO_VALKYRIE	0
#define	REDUINO_GHOST	1
#define	REDUINO_SP	2


/***********************************************************
	萔̒`
***********************************************************/

#define	NDIGIT	4

/* hbg̕\Fw */
#define  DML_DOT_BLACK  0b00
#define  DML_DOT_RED  0b01
#define  DML_DOT_GREEN  0b10
#define  DML_DOT_ORANGE  0b11

// REDUINO_SP̃XCb`s
#define	SP_SW1	2
#define	SP_SW2	4

// REDUINO_VALKYRIẼXCb`s
#define	VALKYRIE_SW1	2
#define	VALKYRIE_SW2	4

// CLCD_BOOSTER̃XCb`s
#define	CLCD_BOOSTER_SW1	6
#define	CLCD_BOOSTER_SW2	7
#define	CLCD_BOOSTER_SW3	8


/***********************************************************
	NX̒`
***********************************************************/

class redDML
{
  private:
	static int8_t system ;

	static uint8_t dataPin ;
	static uint8_t clockPin ;
	static int8_t swPin ;

	static uint8_t dbPin[] ;

	static uint8_t gDL ;

	/* hbg}gbNXLED̕\f[^i[̈FVRAM̂悤Ȃ*/
	static uint8_t gMXR[8] ; /*  */
	static uint8_t gMXG[8] ; /*  */

	static uint8_t gLED ;

	static uint8_t swData ;

  public:
    redDML(uint8_t);

	void clear(void) ;
	void clear(uint8_t);
	void plot(uint8_t, uint8_t, uint8_t) ;

	int ledRead() ;
	int ledRead(uint8_t) ;

	void ledWrite(uint8_t) ;
	void ledWrite(uint8_t, uint8_t) ;

	int swRead(uint8_t) ;

	static void swUpdate() ;
	static void Update() ;
};


#endif
