#include <redDML.h>

#define NBOARD 8

unsigned char board[NBOARD] ;

redDML dml = redDML(REDUINO_GHOST) ;

void setup()
{
}

void loop()
{
  queen(0, NBOARD) ;
  dml.clear(DML_DOT_ORANGE) ;
  delay(5000) ;
}

void
queen(int l, int n)
{
  int i, j ;
  boolean f ;
  
  if (l >= n) {
    queen_display(2, n, 2000) ;
  }

  for (i = 0; i < n; i++) {
    f = false ;
    for (j = l-1; j >= 0; j--) {
      if (board[j] == i) {
        f = true ;
        break ;
      }
      if (board[j] == i - (l - j)) {
        f = true ;
        break ;
      }
      if (board[j] == i + (l - j)) {
        f = true ;
        break ;
      }
    }

    if (f == false) {
      board[l] = i ;
      queen_display(1, l+1, 50) ;
      queen(l+1, n) ;
    }
  }
}

void
queen_display(int color, int n, int t)
{
  int i ;

  dml.clear() ;

  for (i = 0; i < n; i++)
    dml.plot(board[i], i, color) ;

  delay(t) ;
}
